import type { CodeGenOptsBase, ICodeGen } from "./api.js";
/**
 * Zig code generator options.
 */
export interface C11Opts extends CodeGenOptsBase {
    /**
     * Optional name prefix for generated types, e.g. `WASM_`.
     */
    typePrefix: string;
}
/**
 * Zig code generator. Call with options and then pass to {@link generateTypes}
 * (see its docs for further usage).
 *
 * @remarks
 * This codegen generates struct and enum definitions for a {@link TypeColl}
 * given to {@link generateTypes}.
 *
 * @param opts
 */
export declare const C11: (opts?: Partial<C11Opts>) => ICodeGen;
//# sourceMappingURL=c11.d.ts.map