import type { CodeGenOptsBase, ICodeGen } from "./api.js";
/**
 * TypeScript code generator options.
 */
export interface TSOpts extends CodeGenOptsBase {
    /**
     * Indentation string
     *
     * @defaultValue "\t"
     */
    indent: string;
}
/**
 * TypeScript code generator. Call with options and then pass to
 * {@link generateTypes} (see its docs for further usage).
 *
 * @remarks
 * This codegen generates interface and enum definitions for a {@link TypeColl}
 * given to {@link generateTypes}. For structs it will also generate memory
 * mapped wrappers with fully typed accessors.
 *
 * @param opts
 */
export declare const TYPESCRIPT: (opts?: Partial<TSOpts>) => ICodeGen;
//# sourceMappingURL=typescript.d.ts.map